#ifndef PW_SCENE_CAMERA_HPP
#define PW_SCENE_CAMERA_HPP


#include <pw/core/matrix.hpp>
#include <pw/scene/component.hpp>

namespace pw {

class camera : public component {
public:

	enum clearflags {
		color,
		depth,
		none
	};

	enum projection {
		orthographic,
		perspective
	};

	using component::component;

	camera();

	void set_projection(const matrix44d &projection);
	const matrix44d& projection() const;

protected:

	double _fov;
	double _near_plane;
	double _far_plane;

	double _ortho_size = 2;


private:
	matrix44d _projection;
};


}

#endif

