#ifndef PW_SCENE_COMPONENT_HPP
#define PW_SCENE_COMPONENT_HPP

#include <pw/core/globals.hpp>

#include <string>
#include <vector>
#include <memory>

namespace pw {

class node;

/**
 * @brief components represent attributes of the scene nodes
 */
class component {
public:

    typedef std::shared_ptr<component> ref;
    typedef std::vector<ref> array;

    //! only very few components can be attached multiple times
    virtual bool singular() const { return true; }

	component();
    component(const component& other);
    virtual ~component();
};

}

#endif
