#include "pw/scene/node.hpp"

namespace pw {

node::node(const std::string &name)
	: _name(name)
{
}

node::node(const node &node)
	: _children(node.children())
	, _parents(node._parents)
	, _name(node._name)
{
}

node::ref node::clone(const unsigned short &copymode) const
{
	return nullptr;
}

std::string node::name() const
{
	return _name;
}

void node::set_name(const std::string &name)
{
	_name = name;
}

node::ref node::add_child(ref anode)
{
	anode->add_parent(this);
	_children.push_back(anode);
	return anode;
}

void node::add_parent(node *anode)
{
	_parents.push_back(anode);
}

//void node::visit(visitor& visitor)
//{
//	visitor.enter(this);

//	if (visitor.direction == node::visitor::direction::up)
//		this->ascend(visitor);
//	else {
//		this->descend(visitor);
//	}

//	visitor.leave(this);
//}

//void node::ascend(visitor& visitor)
//{
//	for (auto p : this->parents()) p->visit(visitor);
//}

//void node::descend(visitor& visitor)
//{
//	for (auto c : this->children()) c->visit(visitor);
//}

node::~node()
{
	_children.clear();
	_parents.clear();
}

//
// components
//
void node::add_component(component::ref c)
{
	_components.push_back(c);
}

void node::remove_component(component::ref c)
{
	component::array::iterator it = _components.end();

	while ((it = std::find(_components.begin(),_components.end(),std::shared_ptr<component>(c))) != _components.end()) {
		_components.erase(it);
	}
}

const component::array& node::components() const
{
	return _components;
}




}
